const char MAIN_page[] PROGMEM = R"=====(
<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
<style>
button {
  background-color: rgb(200,200,200); 
  border: none;
  color: black;
  width:200px;
  height:40px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  margin: 4px 2px;
  -webkit-appearance: none;
  -moz-appearance: none;
  appearance: none;
  -webkit-transition-duration: 0.4s; /* Safari */
  transition-duration: 0.4s;
  cursor: pointer;
}
button:hover{
  background-color: rgb(220,220,220);
}
div{
  width=90%;
  font-family: Sans-Serif;
  margin-left:20px;
  }
hr{ 
  border: 0; 
  height: 0; 
  border-top: 1px solid rgba(0, 0, 0, 0.1); 
  border-bottom: 1px solid rgba(255, 255, 255, 0.3); }
.graph .labels.x-labels {
  text-anchor: middle;
}

.graph .labels.y-labels {
  text-anchor: end;
  dominant-baseline:middle;
}


.graph {
  margin-top:10px;
}

.graph .Axis {
  stroke: #ccc;
  stroke-dasharray: 0;
  stroke-width: 1;
}

.labels {
  font-size: 20px;
}

.label-title {
  font-weight: bold;
  text-transform: uppercase;
  font-size: 14px;
  fill: black;
}

.data {
  fill: red;
  stroke-width: 1; 
}
</style>
</head>
<body>

<div id="demo">
<h2 style="color:#b4b4b4;font-family: Sans-Serif;">Wireless Multi-Measure System</h1>
<hr style="width:100%">
</div>
<div style="font-family: Sans-Serif;margin-bottom:5px;">
  Temperatur: <span id="Temp">Warte auf erste Messung...</span> &deg;C<br>
</div>
<div>
<svg version="1.2" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" class="graph" aria-labelledby="title" viewBox="0 0 1200 630">
  <title id="title">Temperaturverlauf</title>
<g class="Axis" id="yGrid">
  <line x1="90" x2="90" y1="10" y2="500"></line>
</g>
<g class="Axis" id="xGrid">
  <line x1="90" x2="1090" y1="500" y2="500"></line>
</g>
<g class="Axis" id="xticks"></g>
<g class="Axis" id="yticks"></g>
<g class="labels x-labels" id="xlabs">
  
</g>
<g class="labels", id="titles">
    <text x="560" y="560" class="label-title" id="x-Title">Zeit in s</text>
    <text x="40" y="200" class="label-title" id="y-Title" style="text-anchor: end" transform = "rotate(-90 40 200)">Temperatur in &deg;C</text>
</g>
<g class="labels y-labels" id="ylabs"></g>
<g class="data"></g>
</svg>


</div>

<div>
  <button class="button" id="RecStatus" onclick="toggleRec();">Aufnahme starten</button>
  <button class="button" id="RecSave" onclick="saveRec();">Daten Download</button>
  <button class="button" onclick="clearD();">Daten l&oumlschen</button>
</div>
<div style="font-family: Sans-Serif;">
Datens&aumltze: <span id="N">0</span>
</div>
<script type="text/javascript">
var rec=0;
var txt="";
var outData=[];
var N=0;
var data=document.querySelector('.data');
var graph=document.querySelector('.graph');
var xlab=document.getElementById("xlabs");
var xTicks=document.getElementById("xticks");
var ylab=document.getElementById("ylabs");
var xTicks=document.getElementById("xticks");
var max_x=50, min_x=0,max_y=25,min_y=15;
setxTicks(10);
setyTicks(5);
setxRange(10,min_x,max_x);
setyRange(5,min_y,max_y);
setInterval(function() {
  // Call a function repetatively with 1 Second interval
  getData();
}, 1000); //1000mSeconds update rate

function toggleRec(){
  if(rec==0){
      rec=1;
      document.getElementById("RecStatus").firstChild.data = "Aufnahme stoppen";   
    }else{
      rec=0;
      document.getElementById("RecStatus").firstChild.data = "Aufnahme starten";
    }
}
function clearD(){
  txt="";
  outData=[];
  clearPlot();
  max_x=50;
  setxRange(10,min_x,max_x);  
  N=0;
  document.getElementById("N").innerHTML = N;
}

function saveRec(){
  var txt="";
  for (var i in outData){
      txt+=outData[i]+'\n';
  }  
  var csvData=new Blob([txt],{type:'text/csv;charset=utf-8;'});
  var link = document.createElement('a');
  link.href = window.URL.createObjectURL(csvData);
  link.setAttribute('download', "Temperaturen.csv");
  document.body.appendChild(link);    
  link.click();
  document.body.removeChild(link);
}
 
function getData() {
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
      document.getElementById("Temp").innerHTML =
      this.responseText;
      if(rec==1){
        outData.push(this.responseText);
        DataHandler();
        }
      }
    };
  xhttp.open("GET", "readTemp", true);
  xhttp.send();
}
function DataHandler(){
    var lastY=outData[outData.length-1];
    if(lastY>max_y){
        max_y+=5;
        setyRange(5,min_y,max_y);
        plotArray(outData);
    }
    if(lastY<min_y){
        min_y-=5;
        setyRange(5,min_y,max_y);
        plotArray(outData);
    }
    if(outData.length>=max_x){
       max_x=max_x*2;
       plotArray(outData);
   }else{
      var dat_x=(outData.length-1)/max_x*1000+90;
      var dat_y=500-(outData[outData.length-1]-min_y)/(max_y-min_y)*(500-10);
      appendData(dat_x,dat_y,4,"blue");
   }
    N++;
    document.getElementById("N").innerHTML = N;
}
    
function removeData(){
    data.removeChild(data.childNodes[0]); 
}

function setxLabels(pos,val){
    var newLabel = document.createElementNS("http://www.w3.org/2000/svg","text");
    newLabel.setAttribute("x",pos);
    newLabel.setAttribute("y",530);
    newLabel.innerHTML=val;
    xlab.appendChild(newLabel);
    graph.appendChild(xlab);
}
function setyLabels(pos,val){
    var newLabel = document.createElementNS("http://www.w3.org/2000/svg","text");
    newLabel.setAttribute("x",75);
    newLabel.setAttribute("y",pos);
    newLabel.innerHTML=val;
    ylab.appendChild(newLabel);
    graph.appendChild(ylab);
}
function setxTitle(Title){
    var newTitle = document.getElementById("x-Title");
    newTitle.innerHTML=Title;
}

function setxTicks(Anz){
    for (var i=0;i<=Anz;i++){
       var newTick = document.createElementNS("http://www.w3.org/2000/svg","line");
        newTick.setAttribute("x1",i*1000/(Anz)+90);
        newTick.setAttribute("x2",i*1000/(Anz)+90);
        newTick.setAttribute("y1",500);
        newTick.setAttribute("y2",510);
        xTicks.appendChild(newTick);
    }
}
    
function setyTicks(Anz){
    for (var i=0;i<=Anz;i++){
       var newTick = document.createElementNS("http://www.w3.org/2000/svg","line");
        newTick.setAttribute("x1",80);
        newTick.setAttribute("x2",90);
        newTick.setAttribute("y1",500-i*(500-10)/(Anz));
        newTick.setAttribute("y2",500-i*(500-10)/(Anz));
        xTicks.appendChild(newTick);
    }
}
function clearxTicks(){
  while(xTicks.firstChild){
      xTicks.removeChild(xTicks.firstChild);
  }
} 
function clearyTicks(){
  while(yTicks.firstChild){
      yTicks.removeChild(yTicks.firstChild);
  }
} 
  
function clearxLabels(){
  while(xlab.firstChild){
      xlab.removeChild(xlab.firstChild);
  }
}
    
function clearyLabels(){
  while(ylab.firstChild){
      ylab.removeChild(ylab.firstChild);
  }
}
    
function setxRange(Anz,min,max){
    clearxLabels();
    for (var i=0;i<=Anz;i++){
        setxLabels(i*1000/(Anz)+90,i*(max-min)/Anz+min);
    }
}    
function setyRange(Anz,min,max){
    clearyLabels();
    for (var i=0;i<=Anz;i++){
        setyLabels(500+5-i*(500-10)/(Anz),i*(max-min)/Anz+min);
    }
}
function plotArray(dat){
    clearPlot();
    for(var i=0;i<dat.length;i++){
        var dat_x=i/max_x*1000+90;
        var dat_y=500-(dat[i]-min_y)/(max_y-min_y)*(500-10); 
        appendData(dat_x,dat_y,4,"blue");
    }
}

function clearPlot(){
    while(data.firstChild){
        data.removeChild(data.firstChild);
    }
    setxRange(10,min_x,max_x);
}
    
function appendData(xval,yval,r,color){
    var datapoint = document.createElementNS("http://www.w3.org/2000/svg","circle");
    datapoint.setAttribute("cx",xval);
    datapoint.setAttribute("cy",yval);
    datapoint.setAttribute("r",r);
    datapoint.setAttribute("fill",color);
    data.appendChild(datapoint);
    graph.appendChild(data);
}
</script>
</body>
</html>
)=====";
